//	xxZT[DHT11̃Cu
//	wt]xH쎺	http://jsdiy.webcrow.jp
/*
yDHT11 f[^V[gz
EdAZT[肷܂ł̎Ԃ͎x^xƂ10bimin=6, typ=10, max=15bjB
EԊu1b󂯂B
E背Wc	x:0`50'C	x:20`90RH

ygz
p̃vWFNgɁudht11lib.cvudht11lib.hvB
p̃t@Cňȉ̂悤ɋLqB

#include "dht11lib.h"
void func()
{
	uint8_t isOK;
	uint8_t humidity = 0, temperature = 0;
	isOK = DHT11_GetValue(&humidity, &temperature);
	if (isOK) display(humidity + "%RH " + temperature + "'C");
	else display("error");
}

yXVz
2013/09/20	v1.00	
2015/09/27	v1.10	Ƃǂǂݍ݂Ɏs邱Ƃ̂ŁAǂݍݑCB
					DHT11_Ready()ǉB
*/

#include <avr/io.h>
#include <util/delay.h>
#include "dht11lib.h"


//MHiɂȂ܂ő҂
static	void	WaitForHi()
{
	while ((DHT11_PIN & DHT11_BIT) != DHT11_BIT) { }
}

//MLoɂȂ܂ő҂
static	void	WaitForLo()
{
	while ((DHT11_PIN & DHT11_BIT) == DHT11_BIT) { }
}

//Mo͕ɐ؂ւ
static	void	DDROut()
{
	DHT11_DDR |= DHT11_BIT;	//out
}

//M͕ɐ؂ւ
static	void	DDRIn()
{
	DHT11_DDR &= ~DHT11_BIT;	//in
}

//MLoɂ
static	void	SignalLo()
{
	DHT11_PORT &= ~DHT11_BIT;	//Lo
}

//MHiɂ
static	void	SignalHi()
{
	DHT11_PORT |= DHT11_BIT;	//Hi
}

//M̏Hi/Lo^UlƂĎ擾
static	uint8_t	ReadSignalState()
{
	return (DHT11_PIN & DHT11_BIT);
}

//ZT[ҋ@Ԃɂ
void	DHT11_Ready()
{
	DDRIn();
}

//ZT[瑪l擾
//	humidity:		x̖߂li[ϐ
//		temperature:	x̖߂li[ϐ
//߂l	1:	cɑl
//			0:s	c͑삳Ȃ
uint8_t	DHT11_GetValue(uint8_t* humidity, uint8_t* temperature)
{
	//ZT[擾li[z
	//[0]x̐	[1]x̏iDHT11ł0x00j
	//[2]x̐	[3]x̏iDHT11ł0x00j
	//[4] `FbNTi[0]`[3]̘ả8bitj
	uint8_t sensorValue[5];
	
	uint8_t buf[40];	//f[^ǂݍݗp̃obt@
	uint8_t idx, b, bits, chksum, isOK;
	
	//ʐMJn
	//EʐMJnOAMHił邱ƂOB
	//E18msȏLoɂƁAHiɂB
	SignalHi();
	DDROut();
	SignalLo();	_delay_ms(27);	//ɍ͂Ȃ18ms1.5{Ƃ
	SignalHi();
	DDRIn();
	SignalLo();
	
	//20`40usAZT[Lo
	//Lo80us80usHiiLoɕςj
	WaitForLo();
	WaitForHi();
	
	//f[^擾
	//EJnV[PX̊A܂͒Õf[^irbgj0/1ĂƂHȉԁB
	//	LouԂ玟̃f[^JnB
	//ELo50usB
	//ĚHiA26`28usȂurbg:0vA70usȂurbg:1v\B
	//Ef[^40bitĂB
	for (idx = 0; idx < 40; idx++)
	{
		WaitForLo();
		WaitForHi();
		_delay_us(40);	//28`70us̊Ԃ̒ŃTvO
		buf[idx] = ReadSignalState();
	}
	
	//ZT[40bitƁAf[^M̍}50usLo𑗂ĂiHiɕςj
	WaitForHi();
	
	//ǂݍbitf[^bytef[^ɉHi40bit8bit*5j
	for (idx = 0; idx < 5; idx++)
	{
		bits = 0x00;
		for (b = 0; b < 8; b++)
		{
			bits = (bits << 1) | (buf[idx * 8 + b] ? 1 : 0);
		}
		sensorValue[idx] = bits;
	}
	
	//f[^̑Ó`FbN
	chksum = 0x00;
	for (idx = 0; idx < 4; idx++) { chksum += sensorValue[idx]; }
	isOK = (chksum == sensorValue[4]);
	
	if (isOK)
	{
		*humidity = sensorValue[0];
		*temperature = sensorValue[2];
	}
	
	return isOK;
}
